/******************************************************
STM8S103F2P6 16MHz, IAR1.4+STM8S_StdPeriph_Lib_V2.1.0
******************************************************/
#include <stm8s.h>
#include <iostm003.c>

#define _bitset(bits) ((\
  (bits%010)|\
  (bits/010%010)<<1|\
  (bits/0100%010)<<2|\
  (bits/01000%010)<<3|\
  (bits/010000%010)<<4|\
  (bits/0100000%010)<<5|\
  (bits/01000000%010)<<6|\
  (bits/010000000%010)<<7))
#define binary(bits) _bitset(0##bits) //  u8 a = BINARY(01100011);

#define LEDA       PD_ODR_ODR5
#define LEDB       PC_ODR_ODR5
#define LEDC       PB_ODR_ODR4
#define button0 	 PD_IDR_IDR6
 

enum btn_states {b_prs, b_rls, b_hold} btn0=b_rls;
enum dmodes {normal,started,lobat,sdn,sleep} d_mode=normal;

u8 display_buffer[4]={0,0,0,1};
u8 d_point_position=0;



static void gpio_cfg()
{

   PA_ODR=PB_ODR=PC_ODR=PD_ODR=0;
   PA_DDR=PB_DDR=PC_DDR=PD_DDR=binary(11111111); //conf as output
   PA_CR1=PB_CR1=PC_CR1=PD_CR1=binary(11111111); //push-pull
   PA_CR2=PB_CR2=PC_CR2=PD_CR2=0;                //speed 2MHz

   PA_DDR = binary(11111000); PA_ODR = binary(00000111);
   PB_DDR = binary(11011111);


}
static void clk_cfg()
{
   CLK_DeInit();
	CLK->CKDIVR = 0;
	CLK->PCKENR1 = binary(10000000); //only tim1 clk enabled
}
static void t1_cfg()
{
#define arlv 0xff
  {
  /* Set the Autoreload value */	
   TIM1->ARRH = arlv >> 8;
   TIM1->ARRL = arlv;
  
	/* Select the Counter Mode */
   TIM1->CR1 = TIM1->CR2 = 0;
	TIM1->CR1 = TIM1_COUNTERMODE_CENTERALIGNED1|TIM1_CR1_ARPE|TIM1_CR1_URS;
	TIM1->CR2 = TIM1_CR2_CCPC; 	//preload ccmpr1
	TIM1->RCR = 1;						//repetition counter for center aligned pwm mode
   TIM1->IER = TIM1_IER_UIE;		//update interrupt
  }

   TIM1->CCER1=TIM1->CCER2=TIM1->CCMR1=TIM1->CCMR2=0;
	
   TIM1->CCER1|= TIM1_CCER1_CC1E|TIM1_CCER1_CC1NE|TIM1_CCER1_CC1NP;
   TIM1->CCER1|= TIM1_CCER1_CC2E|TIM1_CCER1_CC2NE|TIM1_CCER1_CC2NP;
	TIM1->CCMR1|= TIM1_OCMODE_PWM1;
   TIM1->CCMR2|= binary(01000000);  //force OC2ref inactive level;
	TIM1->EGR  |= TIM1_EGR_COMG;     //update CCER reg with COM event 
	

	
	TIM1->OISR = 0;		 
	TIM1->DTR  = 0x30; //3us dt delay (62,5ns*48)
	TIM1->CR1 |= TIM1_CR1_CEN;
 	TIM1->BKR  = TIM1_BKR_MOE|TIM1_BKR_OSSR|TIM1_BKR_OSSI|TIM1_LOCKLEVEL_2;

}

INTERRUPT_HANDLER(TIM1_UPD_OVF_TRG_BRK_IRQHandler, 11)
{
#define s_step 314 
static u8 i=0;
static u8 rck=0, dir=0;	

static const u8 s_table [s_step/2]=
{
0,2,5,7,10,12,15,17,20,22,25,27,30,32,35,37,40,42,45,47,50,
52,54,57,59,62,64,67,69,72,74,76,79,81,84,86,88,91,93,95,98,100,
102,104,107,109,111,114,116,118,120,122,125,127,129,131,133,135,138,140,142,144,146,
148,150,152,154,156,158,160,162,164,166,167,169,171,173,175,177,178,180,182,184,185,
187,189,190,192,193,195,197,198,200,201,203,204,206,207,208,210,211,213,214,215,216,
218,219,220,221,223,224,225,226,227,228,229,230,231,232,233,234,235,236,236,237,238,
239,240,240,241,242,242,243,244,244,245,245,246,246,247,247,247,248,248,249,249,249,
249,250,250,250,250,250,250,250,250,250};                           


 if(!i)                                          
 {
 dir=1;i=1; 
   if(rck)
   {
      rck=0;
      TIM1->CCMR1 = TIM1_OCMODE_PWM1; 
		TIM1->CCMR2 = binary(01000000); //force OC2ref inactive level
   }
   else
   {
      rck=1; PD_ODR_ODR5^=1;
		TIM1->CCMR1 = binary(01000000); //force OC1ref inactive level 
		TIM1->CCMR2 = TIM1_OCMODE_PWM1;
   } 
   
   TIM1->EGR|=TIM1_EGR_COMG;
 }
 else if((dir)&&(i<s_step/2-1))
 {
   TIM1->CCR1H=TIM1->CCR2H=0;
   TIM1->CCR1L=TIM1->CCR2L=s_table[i];
   i++;
 }
 else 
 {
   dir=0; i--; 
   TIM1->CCR1H=TIM1->CCR2H=0;
   TIM1->CCR1L=TIM1->CCR2L=s_table[i];
 }
 
	TIM1->SR1 = 0;	//clear interrupts flags	
}

void main()
{
gpio_cfg();
clk_cfg();
t1_cfg();




asm("rim");

  while(1)
  {


  }



}

void assert_failed(uint8_t* file, uint32_t line)
{

}